/*
 * Copyright (C) 2011-2012 Koji Suzuki
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2.1 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
//
//
module button (
                input CLK_128HZ
                , input I
                , output O
                , input R
		);

    reg [2:0] i_stat;
    reg prev_stat;
    reg r_btn_stat = 1'b0;

    always @(R, negedge CLK_128HZ)
    begin
	i_stat <= { i_stat[1:0] , I } ;
	if ( { i_stat , I } == 4'b0000 )
		prev_stat <= 1'b0;
	else if ( { i_stat , I } == 4'b1111 )
		prev_stat <= 1'b1;
	if (R)  r_btn_stat <= 1'b0;
	else if (~prev_stat & ( { i_stat , I } == 4'b1111 ))
		r_btn_stat <= 1'b1;
    end
    assign O = r_btn_stat;
endmodule
