`timescale 10ps / 10ps
`define GTK // use VCD

`define MODULE	tb_counter
`ifdef CLK_LIMIT
`else
`define CLK_LIMIT	200
`endif

module `MODULE;

   reg [23:0] CLK_COUNT;
   reg CLK;   // input
   reg I_UP; // input
   reg I_DN; // input
   reg SEL; // input
   wire [3:0] O;

time_counter # ( .MAX(24) ) top
	( .CLK(CLK) 
		, .I_UP(I_UP)
		, .I_DN(I_DN)
		, .O(O[3:0])
		, .O_UP(O_UP)
		);

   parameter CLKP = 5000000;        //  50us
   parameter CLKH = CLKP/2;      //
   parameter CLKL = CLKP-CLKH;   //
   
   always begin
      #CLKH CLK = 0;
      #CLKL CLK = 1;
   end

   always @(posedge CLK)
   begin
	//if (CLK_COUNT[1:0] == 2'b0) I_UP <= 1'b1;
	//else I_UP <= 1'b0;
	I_UP <= ~I_UP;
   end
`ifdef GTK
   initial begin
      $dumpfile("tb.vcd");
      $dumpvars(0,`MODULE.top);
   end
`endif

   initial begin : test
      CLK_COUNT = 0;
      SEL = 1'b0;
      I_UP = 1'b0;
      I_DN = 1'b0;
      //sys_reset();
      while ( (CLK_COUNT < `CLK_LIMIT) )
      begin
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
      end
//      @(posedge CLK);
      #1
      $display("*** Simulation Complete! ***");
      $finish;
   end

   task sys_reset;
      begin
         //PC2 = 0;
         //#1 RESET = 1;
         //CLK2X = 0;
         @(posedge CLK);
         @(posedge CLK);
         //#1 RESET = 0;
         @(posedge CLK);
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
      end
   endtask // sys_reset
   
endmodule // test
